import { type DocumentNode } from "graphql";
import { ApolloLink } from "@apollo/client/link/core";
import { type Operation } from "@apollo/client/core";
type SHA256Function = (...args: any[]) => string | PromiseLike<string>;
export declare function generatePersistedQueryIdsAtRuntime(options: {
    sha256: SHA256Function;
}): {
    generateHash: (query: DocumentNode) => Promise<string>;
    disable: () => boolean;
};
export declare function sortTopLevelDefinitions(query: DocumentNode): DocumentNode;
export interface PersistedQueryManifestForGeneratingPersistedQueryIds {
    operations: {
        id: string;
        name: string;
    }[];
}
export interface GeneratePersistedQueryIdsFromManifestOptions {
    loadManifest: () => Promise<PersistedQueryManifestForGeneratingPersistedQueryIds> | PersistedQueryManifestForGeneratingPersistedQueryIds;
}
export declare function generatePersistedQueryIdsFromManifest(options: GeneratePersistedQueryIdsFromManifestOptions): {
    generateHash: (document: DocumentNode) => Promise<string>;
    disable: () => boolean;
};
interface PersistedQueryManifestOperation {
    id: string;
    name: string;
    type: "query" | "mutation" | "subscription";
    body: string;
}
export interface PersistedQueryManifestForVerification {
    operations: PersistedQueryManifestOperation[];
}
type PersistedQueryManifestVerificationLinkErrorDetails = {
    reason: "AnonymousOperation";
    operation: Operation;
} | {
    reason: "MultipleOperations";
    operation: Operation;
} | {
    reason: "NoOperations";
    operation: Operation;
} | {
    reason: "UnknownOperation";
    operation: Operation;
} | {
    reason: "OperationMismatch";
    operation: Operation;
    manifestOperation: PersistedQueryManifestOperation;
};
export interface CreatePersistedQueryManifestVerificationLinkOptions {
    loadManifest: () => Promise<PersistedQueryManifestForVerification> | PersistedQueryManifestForVerification;
    onVerificationFailed?: (details: PersistedQueryManifestVerificationLinkErrorDetails) => void;
}
export declare function createPersistedQueryManifestVerificationLink(options: CreatePersistedQueryManifestVerificationLinkOptions): ApolloLink;
export {};
//# sourceMappingURL=index.d.ts.map